#include "vdp2.h"

//#define NBG2_CEL_ADR (VDP2_VRAM_A0 + 0x02000)
#define NBG0_CEL_ADR (VDP2_VRAM_A0 + 0x40000)		// 0x25e40000
//#define NBG2_MAP_ADR (VDP2_VRAM_A0 + 0x10000)
#define NBG0_MAP_ADR (VDP2_VRAM_A0)					// 0x25e00000
#define NBG0_COL_ADR (VDP2_COLRAM)					// 0x25f00000

static void
vblank(struct VDP2 *io)
{
  while((io->reg[TVSTAT] & (1<<3)) == 8);
  while((io->reg[TVSTAT] & (1<<3)) == 0);
}

int
main(void)
{
  unsigned long x = 0;

/*   unsigned char *video_bank_a = (unsigned char *)VDP2_VRAM_A0; */
/*   unsigned char *video_bank_b = (unsigned char *)VDP2_VRAM_B0; */
/*   unsigned char *video_vdp1 = (unsigned char *)SpriteVRAM; */
/*   unsigned short *map = (unsigned short *)NBG2_MAP_ADR; */
/*   unsigned short *cram = (unsigned short *)NBG2_COL_ADR; */

  /* Point to the VDP2 IO address */
  struct VDP2 *vdp2 = (struct VDP2 *)VDP2_IO;

  vdp2->reg[TVMD] = 0x0000;		// Turn off screen

  /* Copy stuff, Add DMA support later */
  Cel2VRAM(pad_cel,(void *)NBG0_CEL_ADR,31808);
  Map2VRAM(pad_map,(void *)NBG0_MAP_ADR,32,23,0,256);
  Pal2CRAM(pad_pal,(void *)NBG0_COL_ADR,256);

  vdp2->reg[PRINA] = 0x0007;

  vdp2->reg[BGON] = 0x001;

  vdp2->reg[CHCTLA] = 0x0010;

  vdp2->reg[PLSZ] = 0x0000;
  vdp2->reg[PNCN0] = 0xC008;

  vdp2->reg[SCRCTL] = 0x0000;

  vdp2->reg[MPOFN] = 0x0000;
  vdp2->reg[MPABN0] = 0x0000;
  vdp2->reg[MPCDN0] = 0x0000;
  
  vdp2->reg[RAMCTL] = 0x0300;

  CYCA0 = 0x0FFFFFFF;
  CYCA1 = 0xCFFFFFFF;
  CYCB0 = 0x44FFFFFF;
  CYCB1 = 0xFFFFFFFF;

  vdp2->reg[TVMD] = 0x8000;

  /* Loop forever */
  while(1)
  {
    vblank(vdp2);
//    vdp2->reg[SCXN2] = x & 0x1FF;
    x++;
  }

  /* We'll never get here */
  return 0;
}
/* EOF */
