#ifndef VDP2_H
#define VDP2_H

#define  SpriteVRAM          0x25C00000

#define  VDP2_VRAM_A0        0x25E00000
#define  VDP2_VRAM_A1        0x25E20000
#define  VDP2_VRAM_B0        0x25E40000
#define  VDP2_VRAM_B1        0x25E60000
#define  VDP2_COLRAM         0x25F00000

#define  VDP1_IO             0x25D00000
#define  VDP2_IO             0x25F80000

/* I don't know if this works on hardware */
#define CHAR_BANK_A0 0x0
#define CHAR_BANK_A1 0x4 /* bit 2 */
#define CHAR_BANK_B0 0x8 /* bit 3 */
#define CHAR_BANK_B1 0xC /* bit 2,3 */

typedef unsigned char Uint8;
typedef unsigned short Uint16;
typedef unsigned long Uint32;

typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned long uint32;

typedef volatile unsigned char vuint8;
typedef volatile unsigned short vuint16;
typedef volatile unsigned long vuint32;

extern const Uint8 yama_cel[];
extern const Uint16 yama_map[];
extern const Uint16 yama_pal[];
extern const Uint8 pad_cel[];
extern const Uint16 pad_map[];
extern const Uint16 pad_pal[];


void Cel2VRAM(const Uint8 *Cel_Data , void *Cell_Adr , Uint32 suu );
void Map2VRAM(const Uint16 *Map_Data , void *Map_Adr , Uint16 suuj , Uint16 suui , Uint16 palnum ,Uint32 mapoff);
void Pal2CRAM(const Uint16 *Pal_Data , void *Col_Adr , Uint32 suu );

enum {
  TVMD,
  EXTEN,
  TVSTAT,
  VRSIZE,
  HCNT,
  VCNT,
  RESERVE, /* ????????????? */
  RAMCTL,
  CYCA0L,
  CYCA0U,
  CYCA1L,
  CYCA1U,
  CYCB0L,
  CYCB0U,
  CYCB1L,
  CYCB1U,
  BGON,
  MZCTL,
  SFSEL,
  SFCODE,
  CHCTLA,
  CHCTLB,
  BMPNA,
  BMPNB,
  PNCN0,
  PNCN1,
  PNCN2,
  PNCN3,
  PNCR,
  PLSZ,
  MPOFN,
  MPOFR,
  MPABN0,
  MPCDN0,
  MPABN1,
  MPCDN1,
  MPABN2,
  MPCDN2,
  MPABN3,
  MPCDN3,
  MPABRA,
  MPCDRA,
  MPEFRA,
  MPGHRA,
  MPIJRA,
  MPKLRA,
  MPMNRA,
  MPOPRA,
  MPABRB,
  MPCDRB,
  MPEFRB,
  MPGHRB,
  MPIJRB,
  MPKLRB,
  MPMNRB,
  MPOPRB,
  SCXIN0,
  SCXDN0,
  SCYIN0,
  SCYDN0,
  ZMXIN0,
  ZMXDN0,
  ZMYIN0,
  ZMYDN0,
  SCXIN1,
  SCXDN1,
  SCYIN1,
  ZMXIN1,
  ZMXDN1,
  ZMYIN1,
  ZMYDN1,
  RESERVED, /* ????????????? */
  SCXN2,
  SCYN2,
  SCXN3,
  SCYN3,
  ZMCTL,
  SCRCTL,
  VCSTAU,
  VCSTAL,
  LSTA0U,
  LSTA0L,
  LSTA1U,
  LSTA1L,
  LCTAU,
  LCTAL,
  BKTAU,
  BKTAL,
  RPMD,
  RPRCTL,
  KTCTL,
  KTAOF,
  OVPNRA,
//  OVPNRA,
  OVPNRB,
  RPTAU,
  RPTAL,
  /* PAGE 309 */
};

/* enum { */
/*   TVMD, */
/*   EXTEN, */
/*   TVSTAT, */
/*   VRSIZE, */
/*   HCNT, */
/*   VCNT, */
/*   RESERVE, */
/*   RAMCTL, */
/*   CYCA0L, */
/*   CYCA0U, */
/*   CYCA1L, */
/*   CYCA1U, */
/*   CYCB0L, */
/*   CYCB0U, */
/*   CYCB1L, */
/*   CYCB1U, */
/*   BGON, */
/*   MZCTL, */
/*   SFSEL, */
/*   CHCTLA, */
/*   CHCTLB, */
/*   BMPNA, */
/*   BMPNB, */
/*   PNCN0, */
/*   PNCN1, */
/*   PNCN2, */
/*   PNCN3, */
/*   PNCR, */
/*   PLSZ, */
/*   MPOFN, */
/*   MPOFR, */

/*   MPABN0, */
/*   MPCDN0, */
/*   MPABN1, */
/*   MPCDN1, */
/*   MPABN2, */
/*   MPCDN2, */
/*   MPABN3, */
/*   MPCDN3, */
/*   MPABRA, */
/*   MPCDRA, */
/*   MPEFRA, */
/*   MPGHRA, */
/*   MPIJRA, */
/*   MPKLRA, */
/*   MPMNRA, */
/*   MPOPRA, */
/*   MPABRB, */
/*   MPCDRB, */
/*   MPEFRB, */
/*   MPGHRB, */
/*   MPIJRB, */
/*   MPKLRB, */
/*   MPMNRB, */
/*   MPOPRB, */
/*   SCXIN0, */
/*   SCXDN0, */
/*   SCYIN0, */
/*   SCYDN0, */
/*   ZMXIN0, */
/*   ZMXDN0, */
/*   ZMYIN0, */
/*   ZMYDN0, */
/*   SCXIN1, */
/*   SCYDN1, */
/*   SCYIN1, */
/*   SCYDN1, */
/*   ZMXDN1, */
/*   ZMYIN1, */
/*   ZMYDN1, */
/*   SCXN2, */
/*   SCYN2, */
/* }; */

/* VRAM cycle pattern registers */
#define CYCA0      (*(vuint32 *)0x25F80010)
#define CYCA1      (*(vuint32 *)0x25F80014)
#define CYCB0      (*(vuint32 *)0x25F80018)
#define CYCB1      (*(vuint32 *)0x25F8001C)

/* Priority Registeres */
#define PRINA       (*(vuint16 *)0x25F800F8)
#define PRINB       (*(vuint16 *)0x25F800FA)

struct VDP1 {
  volatile unsigned short reg[72];
};

struct VDP2 {
  volatile unsigned short reg[72];
};

#endif /* VDP2_H */
/* EOF */
